Index: trunk/kernel/kern/kernel_init.c
===================================================================
--- trunk/kernel/kern/kernel_init.c	(revision 690)
+++ trunk/kernel/kern/kernel_init.c	(revision 1)
@@ -1,7 +1,6 @@
 /*
  * kernel_init.c - kernel parallel initialization
- *
- * Authors :  Mohamed Lamine Karaoui (2015)
- *            Alain Greiner          (2016,2017,2018,2019,2020)
+ * 
+ * Authors :  Alain Greiner  (2016)
  *
  * Copyright (c) Sorbonne Universites
@@ -23,337 +22,103 @@
  */
 
-#include <kernel_config.h>
+#include <almos_config.h>
 #include <errno.h>
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 #include <hal_special.h>
 #include <hal_context.h>
-#include <hal_irqmask.h>
-#include <hal_macros.h>
-#include <hal_ppm.h>
-#include <barrier.h>
-#include <xbarrier.h>
-#include <remote_fifo.h>
+#include <remote_barrier.h>
 #include <core.h>
 #include <list.h>
-#include <xlist.h>
-#include <xhtab.h>
 #include <thread.h>
 #include <scheduler.h>
-#include <ksocket.h>
 #include <kmem.h>
 #include <cluster.h>
+#include <devfs.h>
+#include <sysfs.h>
 #include <string.h>
 #include <memcpy.h>
 #include <ppm.h>
-#include <kcm.h>
 #include <page.h>
-#include <chdev.h>
+#include <device.h>
 #include <boot_info.h>
 #include <dqdt.h>
+#include <dev_icu.h>
 #include <dev_mmc.h>
-#include <dev_dma.h>
-#include <dev_iob.h>
+#include <dev_mwr.h>
+#include <dev_iox.h>
 #include <dev_ioc.h>
-#include <dev_txt.h>
 #include <dev_pic.h>
 #include <printk.h>
 #include <vfs.h>
-#include <devfs.h>
-#include <mapper.h>
-
-///////////////////////////////////////////////////////////////////////////////////////////
-// All the following global variables are replicated in all clusters.
+
+
+#define KERNEL_INIT_SYNCRO  0xA5A5B5B5
+
+///////////////////////////////////////////////////////////////////////////////////////////
+// All these global variables are replicated in all clusters.
 // They are initialised by the kernel_init() function.
-//
-// WARNING : The section names have been defined to control the base addresses of the
-// boot_info structure and the idle thread descriptors, through the kernel.ld script:
-// - the boot_info structure is built by the bootloader, and used by kernel_init.
-//   it must be the first object in the kdata segment.
-// - the array of idle threads descriptors must be placed on the first page boundary after
-//   the boot_info structure in the kdata segment.
-///////////////////////////////////////////////////////////////////////////////////////////
-
-// This variable defines the local boot_info structure
-__attribute__((section(".kinfo")))
-boot_info_t          boot_info;
-
-// This variable defines the "idle" threads descriptors array
-__attribute__((section(".kidle")))
-char                 idle_threads[CONFIG_THREAD_DESC_SIZE *
-                                   CONFIG_MAX_LOCAL_CORES]   CONFIG_PPM_PAGE_ALIGNED;
-
-// This variable defines the local cluster manager
-__attribute__((section(".kdata")))
-cluster_t            cluster_manager                         CONFIG_CACHE_LINE_ALIGNED;
-
-// This variable defines the TXT_TX[0] chdev
-__attribute__((section(".kdata")))
-chdev_t              txt0_tx_chdev                           CONFIG_CACHE_LINE_ALIGNED;
-
-// This variable defines the TXT_RX[0] chdev
-__attribute__((section(".kdata")))
-chdev_t              txt0_rx_chdev                           CONFIG_CACHE_LINE_ALIGNED;
-
-// This variables define the kernel process0 descriptor
-__attribute__((section(".kdata")))
-process_t            process_zero                            CONFIG_CACHE_LINE_ALIGNED;
-
-// This variable defines a set of extended pointers on the distributed chdevs
-__attribute__((section(".kdata")))
-chdev_directory_t    chdev_dir                               CONFIG_CACHE_LINE_ALIGNED;
-
-// This variable contains the input IRQ indexes for the IOPIC controller
-__attribute__((section(".kdata")))
-iopic_input_t        iopic_input                             CONFIG_CACHE_LINE_ALIGNED;
-
-// This variable contains the input IRQ indexes for the LAPIC controller
-__attribute__((section(".kdata")))
-lapic_input_t        lapic_input                             CONFIG_CACHE_LINE_ALIGNED;
+///////////////////////////////////////////////////////////////////////////////////////////
+
+// This variable defines the local cluster manager 
+cluster_t            cluster_manager    CACHELINE_ALIGNED; 
+
+// This variable defines the kernel process descriptor and associated thread
+process_t            process_zero       CACHELINE_ALIGNED;            
+thread_t             thread_zero        CACHELINE_ALIGNED;
+
+// This variable contains the extended pointers on the device descriptors
+devices_directory_t  devices_dir        CACHELINE_ALIGNED;
+
+// This variable contains the input IRQ indexes for the PIC and ICU devices
+devices_input_irq_t  devices_input_irq   CACHELINE_ALIGNED;
+
+// This variable synchronizes the cores during kernel_init()
+volatile uint32_t    local_sync_init = 0;  
 
 // This variable defines the local cluster identifier
-__attribute__((section(".kdata")))
-cxy_t                local_cxy                               CONFIG_CACHE_LINE_ALIGNED;
-
-// This variable is used for core[0] cores synchronisation in kernel_init()
-__attribute__((section(".kdata")))
-xbarrier_t           global_barrier                          CONFIG_CACHE_LINE_ALIGNED;
-
-// This variable is used for local cores synchronisation in kernel_init()
-__attribute__((section(".kdata")))
-barrier_t            local_barrier                           CONFIG_CACHE_LINE_ALIGNED;
-
-// This variable defines the array of supported File System contexts
-__attribute__((section(".kdata")))
-vfs_ctx_t            fs_context[FS_TYPES_NR]                 CONFIG_CACHE_LINE_ALIGNED;
-
-// This array is used for debug, and describes the kernel locks usage,
-// It must be kept consistent with the defines in kernel_config.h file.
-__attribute__((section(".kdata")))
-char * lock_type_str[] =
-{
-    "unused_0",              //  0   must be unused to help debug
-
-    "CLUSTER_KCM",           //  1
-    "SCHED_STATE",           //  2
-    "VMM_STACK",             //  3
-    "VMM_MMAP",              //  4
-    "KCM_STATE",             //  5
-    "KHM_STATE",             //  6
-    "HTAB_STATE",            //  7
-    "CORE_ALARMS",           //  8
-
-    "VFS_CTX",               //  9
-    "PPM_FREE",              // 10
-    "THREAD_JOIN",           // 11
-    "XHTAB_STATE",           // 12
-    "CHDEV_QUEUE",           // 13
-    "CHDEV_TXT0",            // 14
-    "CHDEV_TXTLIST",         // 15
-    "PAGE_STATE",            // 16
-    "MUTEX_STATE",           // 17
-    "CONDVAR_STATE",         // 18
-    "SEM_STATE",             // 19
-    "PROCESS_CWD",           // 20
-    "BARRIER_STATE",         // 21
-    "LISTEN_SOCKET",         // 22
-
-    "CLUSTER_PREFTBL",       // 23
-
-    "SOCKET_STATE",          // 24
-    "PPM_DIRTY",             // 25
-    "CLUSTER_LOCALS",        // 26
-    "CLUSTER_COPIES",        // 27
-    "PROCESS_CHILDREN",      // 28
-    "PROCESS_USERSYNC",      // 29
-    "PROCESS_FDARRAY",       // 30
-    "PROCESS_DIR",           // 31
-    "VMM_VSL",               // 32
-
-    "PROCESS_THTBL",         // 33
-
-    "MAPPER_STATE",          // 34
-    "VFS_SIZE",              // 35
-    "VFS_FILE",              // 36
-    "VFS_MAIN",              // 37
-    "FATFS_FAT",             // 38
-    "FBF_WINDOWS",           // 39
-};        
-
-// debug variables to analyse the sys_read()  syscalls timing
-
-#if DEBUG_SYS_READ
-uint32_t   enter_sys_read;
-uint32_t   exit_sys_read;
-
-uint32_t   enter_devfs_read;
-uint32_t   exit_devfs_read;
-
-uint32_t   enter_txt_read;
-uint32_t   exit_txt_read;
-
-uint32_t   enter_chdev_cmd_read;
-uint32_t   exit_chdev_cmd_read;
-
-uint32_t   enter_chdev_server_read;
-uint32_t   exit_chdev_server_read;
-
-uint32_t   enter_tty_cmd_read;
-uint32_t   exit_tty_cmd_read;
-
-uint32_t   enter_tty_isr_read;
-uint32_t   exit_tty_isr_read;
-#endif
-
-// debug variables  to analyse the sys_write() syscall timing
-
-#if DEBUG_SYS_WRITE    
-uint32_t   enter_sys_write;
-uint32_t   exit_sys_write;
-
-uint32_t   enter_devfs_write;
-uint32_t   exit_devfs_write;
-
-uint32_t   enter_txt_write;
-uint32_t   exit_txt_write;
-
-uint32_t   enter_chdev_cmd_write;
-uint32_t   exit_chdev_cmd_write;
-
-uint32_t   enter_chdev_server_write;
-uint32_t   exit_chdev_server_write;
-
-uint32_t   enter_tty_cmd_write;
-uint32_t   exit_tty_cmd_write;
-
-uint32_t   enter_tty_isr_write;
-uint32_t   exit_tty_isr_write;
-#endif
-
-// intrumentation variables : cumulated costs per syscall type in cluster
-
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-__attribute__((section(".kdata")))
-uint32_t   syscalls_cumul_cost[SYSCALLS_NR];
-
-__attribute__((section(".kdata")))
-uint32_t   syscalls_occurences[SYSCALLS_NR];
-#endif
-
-///////////////////////////////////////////////////////////////////////////////////////////
-// This function displays the ALMOS_MKH banner.
-///////////////////////////////////////////////////////////////////////////////////////////
-static void print_banner( uint32_t nclusters , uint32_t ncores )
-{
-    printk("\n"
-           "                    _        __    __     _____     ______         __    __    _   __   _     _   \n"
-           "          /\\       | |      |  \\  /  |   / ___ \\   / _____|       |  \\  /  |  | | / /  | |   | |  \n"
-           "         /  \\      | |      |   \\/   |  | /   \\ | | /             |   \\/   |  | |/ /   | |   | |  \n"
-           "        / /\\ \\     | |      | |\\  /| |  | |   | | | |_____   ___  | |\\  /| |  |   /    | |___| |  \n"
-           "       / /__\\ \\    | |      | | \\/ | |  | |   | | \\_____  \\ |___| | | \\/ | |  |   \\    |  ___  |  \n"
-           "      / ______ \\   | |      | |    | |  | |   | |       | |       | |    | |  | |\\ \\   | |   | |  \n"
-           "     / /      \\ \\  | |____  | |    | |  | \\___/ |  _____/ |       | |    | |  | | \\ \\  | |   | |  \n"
-           "    /_/        \\_\\ |______| |_|    |_|   \\_____/  |______/        |_|    |_|  |_|  \\_\\ |_|   |_|  \n"
-           "\n\n\t\t Advanced Locality Management Operating System / Multi Kernel Hybrid\n"
-           "\n\n\t\t %s / %d cluster(s) / %d core(s) per cluster\n\n",
-           CONFIG_VERSION , nclusters , ncores );
+cxy_t                local_cxy;
+
+
+///////////////////////////////////////////////////////////////////////////////////////////
+// This function displays the ALMOS_MKH.banner.
+///////////////////////////////////////////////////////////////////////////////////////////
+static void print_boot_banner()
+{ 
+        printk("\n           ____        ___        ___       ___    _______    ________         ___       ___   ___     ___   \n");
+        printk("          /    \\      |   |      |   \\     /   |  /  ___  \\  /  ____  |       |   \\     /   | |   |   /  / \n");
+        printk("         /  __  \\      | |        |   \\___/   |  |  /   \\  | | /    |_/        |   \\___/   |   | |   /  /  \n");
+        printk("        /  /  \\  \\     | |        |  _     _  |  | |     | | | |______   ___   |  _     _  |   | |__/  /     \n");
+        printk("       /  /____\\  \\    | |        | | \\   / | |  | |     | | \\______  \\ |___|  | | \\   / | |   |  __  <  \n");
+        printk("      /   ______   \\   | |     _  | |  \\_/  | |  | |     | |  _     | |        | |  \\_/  | |   | |  \\  \\  \n");
+        printk("     /   /      \\   \\  | |____/ | | |       | |  |  \\___/  | | \\____/ |        | |       | |   | |   \\  \\\n");
+        printk("    /_____/    \\_____\\|_________/|___|     |___|  \\_______/  |________/       |___|     |___| |___|   \\__\\\n");
+
+
+        printk("\n\n\t\t\t\t Multi-Kernel Advanced Locality Management Operating System\n");
+        printk("\t\t\t\t   %s \n\n\n", CONFIG_ALMOS_VERSION );
 }
 
 
 ///////////////////////////////////////////////////////////////////////////////////////////
-// This function initializes the TXT_TX[0] and TXT_RX[0] chdev descriptors, implementing
-// the "kernel terminal", shared by all kernel instances for debug messages. 
-// These chdev are implemented as global variables (replicated in all clusters),
-// because this terminal is used before the kmem allocator initialisation, but only 
-// the chdevs in cluster 0 are registered in the "chdev_dir" directory.
-// As this TXT0 chdev supports only the TXT_SYNC_WRITE command, we don't create
-// a server thread, we don't allocate a WTI, and we don't initialize the waiting queue.
-// Note: The TXT_RX[0] chdev is created, but is not used by ALMOS-MKH (september 2018).
+// This static function allocates memory for all devices descriptors associated 
+// to peripherals contained in the local cluster: 
+// - the internal (replicated) devices are placed in the local cluster.
+// - the external devices are pseudo-randomly distributed on all clusters. 
+// It initialises these device descriptors as specified by the boot_info_t structure,
+// including the dynamic linking with the driver for the specified implementation.
+// Finally, all copies of the devices directory are initialised.
+// TODO check that cluster IO contains a PIC and IOB [AG]
 ///////////////////////////////////////////////////////////////////////////////////////////
 // @ info    : pointer on the local boot-info structure.
 ///////////////////////////////////////////////////////////////////////////////////////////
-static void __attribute__ ((noinline)) txt0_device_init( boot_info_t * info )
+static void devices_init( boot_info_t * info )
 {
     boot_device_t * dev_tbl;         // pointer on array of devices in boot_info
-    uint32_t        dev_nr;          // actual number of devices in this cluster
-    xptr_t          base;            // remote pointer on segment base
-    uint32_t        func;            // device functional index
-    uint32_t        impl;            // device implementation index
-    uint32_t        i;               // device index in dev_tbl
-    uint32_t        x;               // X cluster coordinate
-    uint32_t        y;               // Y cluster coordinate
-
-    // get number of peripherals and base of devices array from boot_info
-    dev_nr      = info->ext_dev_nr;
-    dev_tbl     = info->ext_dev;
-
-    // loop on external peripherals to find TXT device
-    for( i = 0 ; i < dev_nr ; i++ )
-    {
-        base        = dev_tbl[i].base;
-        func        = FUNC_FROM_TYPE( dev_tbl[i].type );
-        impl        = IMPL_FROM_TYPE( dev_tbl[i].type );
-
-        if (func == DEV_FUNC_TXT )
-        {
-            // initialize TXT_TX[0] chdev
-            txt0_tx_chdev.func    = func;
-            txt0_tx_chdev.impl    = impl;
-            txt0_tx_chdev.channel = 0;
-            txt0_tx_chdev.base    = base;
-            txt0_tx_chdev.is_rx   = false;
-            remote_busylock_init( XPTR( local_cxy , &txt0_tx_chdev.wait_lock ),
-                                  LOCK_CHDEV_TXT0 );
-            
-            // make TXT specific initialisations 
-            dev_txt_init( &txt0_tx_chdev );                 
-
-            // initialize TXT_RX[0] chdev
-            txt0_rx_chdev.func    = func;
-            txt0_rx_chdev.impl    = impl;
-            txt0_rx_chdev.channel = 0;
-            txt0_rx_chdev.base    = base;
-            txt0_rx_chdev.is_rx   = true;
-            remote_busylock_init( XPTR( local_cxy , &txt0_rx_chdev.wait_lock ),
-                                  LOCK_CHDEV_TXT0 );
-            
-            // make TXT specific initialisations 
-            dev_txt_init( &txt0_rx_chdev );
-
-            // register TXT_TX[0] & TXT_RX[0] in chdev_dir[x][y]
-            // for all valid clusters             
-            for( x = 0 ; x < info->x_size ; x++ )
-            {
-                for( y = 0 ; y < info->y_size ; y++ )
-                {
-                    cxy_t cxy = HAL_CXY_FROM_XY( x , y );
-
-                    if( cluster_is_active( cxy ) )
-                    {
-                        hal_remote_s64( XPTR( cxy , &chdev_dir.txt_tx[0] ) ,
-                                        XPTR( local_cxy , &txt0_tx_chdev ) );
-                        hal_remote_s64( XPTR( cxy , &chdev_dir.txt_rx[0] ) ,
-                                        XPTR( local_cxy , &txt0_rx_chdev ) );
-                    }
-                }
-            }
-
-            hal_fence();
-        }
-	} // end loop on devices
-}  // end txt0_device_init()
-
-///////////////////////////////////////////////////////////////////////////////////////////
-// This function allocates memory and initializes the chdev descriptors for the internal
-// peripherals contained in the local cluster, other than the LAPIC, as specified by 
-// the boot_info, including the linking with the driver for the specified implementation.
-// The relevant entries in all copies of the devices directory are initialised.
-///////////////////////////////////////////////////////////////////////////////////////////
-// @ info    : pointer on the local boot-info structure.
-///////////////////////////////////////////////////////////////////////////////////////////
-static void __attribute__ ((noinline)) internal_devices_init( boot_info_t * info )
-{
-    boot_device_t * dev_tbl;         // pointer on array of internaldevices in boot_info
 	uint32_t        dev_nr;          // actual number of devices in this cluster
+	xptr_t          xp_dev;          // extended pointer on device descriptor
+	xptr_t          xp_dev_bis;      // extended pointer on second device descriptor
 	xptr_t          base;            // remote pointer on segment base
+	uint32_t        size;            // channel size (bytes)
+    uint32_t        type;            // peripheral type
     uint32_t        func;            // device functionnal index
     uint32_t        impl;            // device implementation index
